package com.hzya.frame.seeyon.service.impl;
import cn.hutool.core.lang.UUID;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.execsql.service.IExecSqlService;
import com.hzya.frame.seeyon.dao.ICapFormDefinitionDao;
import com.hzya.frame.seeyon.dao.ISeeYonDao;
import com.hzya.frame.seeyon.entity.CapFormDefinitionEntity;
import com.hzya.frame.seeyon.entity.CtpFileEntity;
import com.hzya.frame.seeyon.entity.SeeyonEntity;
import com.hzya.frame.seeyon.service.ICtpAttachmentService;
import com.hzya.frame.seeyon.service.INoProcessService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.checkerframework.checker.units.qual.A;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.atomic.AtomicReference;

/**
 *
 * @content 无流程表单公用service
 * @className: Administrator
 * @author laborer
 * @date 2024-09-09 14:53
 *
 */

@Service(value = "NoProcessServiceImpl")
public class NoProcessServiceImpl implements INoProcessService {
    private static final Logger logger = LoggerFactory.getLogger(NoProcessServiceImpl.class);
    @Autowired
    private ICapFormDefinitionDao capFormDefinitionDao;
    @Autowired
    private ISeeYonDao seeYonDao;
    @Autowired
    private IExecSqlService execSqlService;
    @Autowired
    private ICtpAttachmentService ctpAttachmentService;
    @Override
    public JsonResultEntity DeleteProcessField(JSONObject requestData) {
        List<String>count  =new ArrayList<>();
        JSONObject jsonStrObj = requestData.getJSONObject("jsonStr");
        String formCode = jsonStrObj.getString("formCode");
        String fieldName = jsonStrObj.getString("fieldName");
        String fieldValue = jsonStrObj.getString("fieldValue");
        if(StrUtil.isEmpty(formCode)){
            return new JsonResultEntity("表单编码不能为空：formCode",false);
        }
        if(StrUtil.isEmpty(fieldName)){
            return new JsonResultEntity("字段名称不能为空：fieldName",false);
        }
        if(StrUtil.isEmpty(fieldValue)){
            return new JsonResultEntity("字段值不能为空：fieldValue",false);
        }

        //通过表单编号获取表单字段信息
        CapFormDefinitionEntity fieldInfo = new CapFormDefinitionEntity();
        fieldInfo.setAppbindInfo(formCode);
        fieldInfo.setDataSourceCode("djoatest");
        List<CapFormDefinitionEntity>capFormDefinitionEntityList = capFormDefinitionDao.getFormFiled(fieldInfo);
        if(CollectionUtils.isEmpty(capFormDefinitionEntityList)){
            return new JsonResultEntity("通过表单编号查询表单有误，请检查表单编号："+formCode,false);
        }

        try {
            capFormDefinitionEntityList.forEach(item->{
                String appbindInfo = item.getAppbindInfo();
                //格式化字段信息
                JSONObject jsonObject = JSONObject.parseObject(appbindInfo);
                boolean queryFlag = false;
                //如果模版编号相同则继续删除，反正跳过
                if(formCode.equals(jsonObject.getString("formCode"))){
                    JSONObject field = JSONObject.parseObject(item.getFieldInfo());
                    JSONObject frontFormmain = field.getJSONObject("front_formmain");
                    JSONArray formsons = field.getJSONArray("formsons");
                    JSONArray fieldInfoTable =  frontFormmain.getJSONArray("fieldInfo");
                    //验证需要删除的条件字段在表单属性中是否存在
                    for (int i = 0; i < fieldInfoTable.size(); i++) {
                        JSONObject fieldInfoTableObj = fieldInfoTable.getJSONObject(i);
                        String name = fieldInfoTableObj.getString("name");
                        //如果表单属性中存在该字段则验证通过，如果不存在直接返回错误
                       if(name.equals(fieldName)){
                           queryFlag = true;

                       }
                    }
                    //验证通过获取数据库表名称进行数据删除
                    if(queryFlag){
                        String tableName = frontFormmain.getString("tableName");
                        //如果主表名称获取主表的主键进行数据删除
                        fieldInfo.setTableName(tableName);
                        fieldInfo.setFieldName(fieldName);
                        fieldInfo.setFieldValue(fieldValue);
                        List<CapFormDefinitionEntity>dataFormList = capFormDefinitionDao.getFormFiledByFileValue(fieldInfo);
                        if(CollectionUtils.isNotEmpty(dataFormList)){
                            dataFormList.forEach(item1->{
                                String id = item1.getId();
                                count.add(id);
                                fieldInfo.setFieldName("id");
                                fieldInfo.setId(id);
                                capFormDefinitionDao.deleteByKey(fieldInfo);
                                //循环该表单下面的所有子表信息进行子表删除
                                if(CollectionUtils.isNotEmpty(formsons)){
                                    formsons.forEach(formsonsItem->{
                                        JSONObject jsonObjectBoddy = JSONObject.parseObject(formsonsItem.toString());
                                        String bodyTableName = jsonObjectBoddy.getString("tableName");
                                        fieldInfo.setTableName(bodyTableName);
                                        fieldInfo.setFieldName("formmain_id");
                                        fieldInfo.setId(id);
                                        capFormDefinitionDao.deleteByKey(fieldInfo);
                                    });
                                }
                            });
                        }
                    }
                }
            });
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        return new JsonResultEntity("删除成功,删除的数据ID"+ JSON.toJSONString(count),true);
    }

    @Override
    public JsonResultEntity UpdateProcessField(JSONObject requestData) {
        SeeyonEntity entity = new SeeyonEntity();
        entity.setDataSourceCode("WS_OA");
        JSONObject jsonStrObj = requestData.getJSONObject("jsonStr");
        String billCode = jsonStrObj.getString("billCode");
        String field0018 = jsonStrObj.getString("field0018");//报关单附件
        String field0021 = jsonStrObj.getString("field0021");//放行通知书附件

        String field0057 = jsonStrObj.getString("field0057");//委托报关协议附件
        String field0019 = jsonStrObj.getString("field0019");//合同附件
        String field0020 = jsonStrObj.getString("field0020");//提单附件
        String field0062 = jsonStrObj.getString("field0062");//国税要求的其他资料附件
        String field0022 = jsonStrObj.getString("field0022");//国税发票
        if(StrUtil.isEmpty(billCode)) {
            return BaseResult.getFailureMessageEntity("单据编码不能为空：billCode");
        }
        //如果附件信息全部为空，则直接提示更新成功
        if(
           StrUtil.isEmpty(field0018)
           &&StrUtil.isEmpty(field0021)
           &&StrUtil.isEmpty(field0057)
           &&StrUtil.isEmpty(field0019)
           &&StrUtil.isEmpty(field0020)
           &&StrUtil.isEmpty(field0062)
           &&StrUtil.isEmpty(field0022)
        ){
            return BaseResult.getFailureMessageEntity("更新失败，报关单附件、放行通知书附件、委托报关协议附件、合同附件、提单附件、国税要求的其他资料附件、国税发票：不能同时为空");
        }
        //如果单据编号查询OA中是否存咋，如果存在则继续，如果不存在则直接返回
        String sqlSaleOutQty = "select id,field0015 as billCode from formmain_7676 where field0015 = '"+billCode+"'";
        String dataSourceCode = "WS_OA";
        try {
            List<HashMap<String,Object>> hashMaps = seeYonDao.execSelectSql(sqlSaleOutQty,entity);
            if(CollectionUtils.isEmpty(hashMaps) || hashMaps.size() >1){
                return BaseResult.getFailureMessageEntity("该销售订单号在OA中不存在或存在多条请检查："+billCode+"存在条数："+hashMaps.size());
            }
            HashMap hashMap = hashMaps.get(0);
            String id = hashMap.get("id").toString();
            if(StrUtil.isEmpty(id)){
                return BaseResult.getFailureMessageEntity("该销售订单号在OA中不存在或存在多条请检查："+billCode);
            }
            StringBuffer sb = new StringBuffer();
            sb.append("update formmain_7676 set ");
            //处理附件与表单的关联关系
            if(StrUtil.isNotEmpty(field0018)){
                String uuid = String.valueOf(UUID.randomUUID().getLeastSignificantBits());
                ctpAttachmentService.saveAttachment(field0018,id,uuid ,dataSourceCode);
                sb.append(" field0018 = '"+uuid+"',");
            }
            if(StrUtil.isNotEmpty(field0021)){
                String uuid = String.valueOf(UUID.randomUUID().getLeastSignificantBits());
                ctpAttachmentService.saveAttachment(field0021,id,uuid ,dataSourceCode);
                sb.append(" field0021 = '"+uuid+"',");
            }
            if(StrUtil.isNotEmpty(field0057)){
                String uuid = String.valueOf(UUID.randomUUID().getLeastSignificantBits());
                ctpAttachmentService.saveAttachment(field0057,id,uuid ,dataSourceCode);
                sb.append(" field0057 = '"+uuid+"',");
            }
            if(StrUtil.isNotEmpty(field0019)){
                String uuid = String.valueOf(UUID.randomUUID().getLeastSignificantBits());
                ctpAttachmentService.saveAttachment(field0019,id,uuid ,dataSourceCode);
                sb.append(" field0019 = '"+uuid+"',");
            }
            if(StrUtil.isNotEmpty(field0020)){
                String uuid = String.valueOf(UUID.randomUUID().getLeastSignificantBits());
                ctpAttachmentService.saveAttachment(field0020,id,uuid ,dataSourceCode);
                sb.append(" field0020 = '"+uuid+"',");
            }
            if(StrUtil.isNotEmpty(field0062)){
                String uuid = String.valueOf(UUID.randomUUID().getLeastSignificantBits());
                ctpAttachmentService.saveAttachment(field0062,id,uuid ,dataSourceCode);
                sb.append(" field0062 = '"+uuid+"',");
            }
            if(StrUtil.isNotEmpty(field0022)){
                String uuid = String.valueOf(UUID.randomUUID().getLeastSignificantBits());
                ctpAttachmentService.saveAttachment(field0022,id,uuid ,dataSourceCode);
                sb.append(" field0022 = '"+uuid+"',");
            }
            sb.append(" field0070 = null");
            sb.append(" where id = '"+id+"'");
            logger.info("更新表单sql："+sb.toString());
            entity.setSqlStr(sb.toString());
            Integer count = seeYonDao.updateFileBySqlSre(entity);
            return BaseResult.getSuccessMessageEntity("更新成功");
        } catch (Exception e) {
            logger.error(e.getMessage());
            return BaseResult.getFailureMessageEntity("更新失败，请联系管理员");
        }
    }
}
